$mod51
Bag1 		Equ 20H
Bag2 		Equ 21H
Bag3 		Equ 22H
Bag4 		Equ 23H
Tampung		Equ 25H
Angka1  	Equ 26H
Angka2  	Equ 27H
Temp1		Equ 28H
Temp2		Bit 1
write		Equ 700H	
PortA		Equ 2000H
PortB		Equ 2001H
PortC		Equ 2002H
CPort		Equ 2003H
CW		Equ 0080H
Tekan		Bit P1.0
	
	ORG 4000H

Start:		MOV	SP,#30H
		ACALL   Delay                   

;==================================================
; 		Inisialisasi PPI
;==================================================

		MOV	DPTR,#CPort
		MOV	A,#CW
		MOVX	@DPTR,A

;==================================================
;		   Kondisi Awal
;==================================================

Kond:   	MOV 	Bag1,#0C1H
		MOV 	R1,#0F5H
		MOV 	R5,#0FEH
		MOV 	R7,#60H	
		MOV 	R0,#20H	
		SETB 	Temp2

;==================================================
;		   Tampilan Awal
;==================================================

		MOV 	A,#0FFH
Awal:		CPL 	A
		MOV 	DPTR,#PortA
		MOVX 	@DPTR,A
		CPL 	A
		MOV 	DPTR,#PortB
		MOVX 	@DPTR,A
		CPL 	A
	
;==================================================
;		     Pembacaan Tombol
;==================================================

Cek: 		SETB 	Tekan
	
		JNB 	Temp2,Cek_ulang
		DJNZ 	R7,Cek_ulang
		MOV 	R7,#60H	
		DJNZ 	R0,Cek_ulang
		SJMP 	Awal
		MOV 	R0,#20h	

cek_ulang:	JB 	Tekan,Cek

		MOV 	A,R5
		CPL 	A
		MOV 	R5,A	

Cek_lagi:	SETB 	Tekan
		ACALL 	Random

		DJNZ 	R7,Lanjut
		MOV 	R7,#60H	
		DJNZ 	R0,Lanjut
		ACALL 	Tampil
		MOV 	R0,#20H	

Lanjut:		JNB 	Tekan,Cek_lagi	
		CLR 	Temp2

;===================================================
;	              Dadu Digital
;===================================================

Utama:		MOV 	A,Angka1
		MOV 	B,R1
		ACALL 	Bagi	
		ACALL 	Scan11

		MOV 	A,Angka2
		MOV 	B,R1
		ACALL 	Bagi
		ACALL 	Scan21
	
		MOV 	A,R1
		XRL 	A,#01
		MOV 	R1,A
	
		AJMP 	Cek

;==================================================
;	        Scanning Dadu Pertama
;==================================================

Scan11: 	CJNE 	R6,#0,Scan12
		MOV 	A,#10111111b

Scan12: 	CJNE 	R6,#01,Scan13
		MOV 	A,#11011011b

Scan13: 	CJNE 	R6,#02,Scan14
		MOV 	A,#10011011b

Scan14: 	CJNE 	R6,#03,Scan15
		MOV 	A,#11010010b

Scan15: 	CJNE 	R6,#04,Scan16
		MOV 	A,#10010010b

Scan16: 	CJNE 	R6,#05,Hasil1
		MOV 	A,#11000000b

Hasil1:		MOV 	DPTR,#PortA
		MOVX 	@DPTR,A 	
		RET

;==================================================
;	        Scanning Dadu Kedua
;==================================================

Scan21: 	CJNE 	R6,#0,Scan22
		MOV 	A,#10111111b

Scan22: 	CJNE 	R6,#01,Scan23
		MOV 	A,#11011011b

Scan23: 	CJNE 	R6,#02,Scan24
		MOV 	A,#10011011b

Scan24: 	CJNE 	R6,#03,Scan25
		MOV 	A,#11010010b

Scan25: 	CJNE 	R6,#04,Scan26
		MOV 	A,#10010010b

Scan26: 	CJNE 	R6,#05,Hasil2
		MOV 	A,#11000000b

Hasil2:		MOV 	DPTR,#PortB
		MOVX 	@DPTR,A 	
		RET
	
;======================================================
;		       Tampilan
;======================================================

Tampil:		MOV 	A,R5
		RL 	A
		MOV 	DPTR,#PortA
		MOVX 	@DPTR,A
		MOV 	DPTR,#PortB
		MOVX 	@DPTR,A
		MOV 	R5,A
		RET

;======================================================
;		Random Angka 8-Bit (LFSR)
;======================================================

Random:		MOV 	A,Bag4 	 
  		RRC 	A   
  		MOV 	Bag4,Bag3
		MOV 	Bag3,Bag2   
  		MOV 	Bag2,Bag1 	 
  		MOV 	A,Bag4 	 
  		RRC 	A 		 
  		MOV	Tampung,A 	 
  		MOV 	A,Bag1    
  		RLC 	A 		 
  		MOV 	Bag1,A  	 
  		MOV  	A,Tampung 	 
  		XRL 	A,Bag1  	 
  		MOV 	Tampung,A 	 
		MOV 	A,Bag4    
  		RRC 	A   
  		MOV 	Bag4,A 	
  		MOV 	A,Bag3    
  		RRC 	A   
  		MOV 	Bag3,A 	 
  		MOV  	A,Bag2   
  		RRC 	A   
  		MOV 	Bag2,A 	 
  		MOV 	A,Tampung 	
  		RLC 	A   
  		MOV 	Bag1,A 	 
  		MOV 	Angka1,Bag1 	 
  		MOV 	Angka2,Bag3
		RET 

;===================================================
;		    Waktu Tunda
;===================================================

Delay: 		MOV 	R2,#0FFH
Del1:		MOV 	R3,#0FFH
		DJNZ 	R3,$
		DJNZ 	R2,Del1
        	RET
	
;==================================================
;	Pembagian 16-Bit Dengan 8-Bit
;==================================================	
	
Bagi:		MUL 	AB
		MOV 	R4,A
		MOV 	A,B
		MOV 	B,#06H
		DIV 	AB
		MOV 	Temp1,B
		MOV 	R0,#Temp1
		MOV 	A,R4
		XCHD 	A,@R0
		SWAP 	A
		MOV 	B,#06H
		DIV 	AB
		MOV 	A,B
		SWAP 	A
		XRL 	A,@R0
		MOV 	B,#06H
		DIV 	AB
		MOV 	R6,B
		RET
		
	END